-- radio state machine

beginStateMachine()

	onMsg("buildMenu", function(msg)
	
		if (repairMenu()) then return end
		
		local radioMode = this.getGameObjectServer().getMusicManager().getRadioMode();
		
		-- build the pie menu
		clearPieMenu();
		local button ;
		if (radioMode ~= RADIO_OFF) then
			button = addPieMenuButton("pm_turnRadioOff", "noRadio");
			button.addDescription(USERACTION, "true");
			-- button.addIcon("guiIconComfort");
		end
		if (radioMode ~= RADIO_DEFAULT) then
			button = addPieMenuButton("pm_singlesRadioChannel", "singlesRadio");
			button.addDescription(USERACTION, "true");
			-- button.addIcon("guiIconComfort");
		end
		if (radioMode ~= RADIO_MYMUSIC) then
			button = addPieMenuButton("pm_myMusicRadioChannel", "myMusicRadio");
			button.addDescription(USERACTION, "true");
			-- button.addIcon("guiIconComfort");
		end
	end )

	onMsg("singlesRadio", function(msg)
		if (not this.isBroken()) then
			playSound("switchOn");
			local gameObjectServer = this.getGameObjectServer()
			gameObjectServer.addListener(-999);
			gameObjectServer.getMusicManager().setRadioMode(RADIO_DEFAULT);
		end
	end )

	onMsg("myMusicRadio", function(msg)
		if (not this.isBroken()) then
			playSound("switchOn");
			local gameObjectServer = this.getGameObjectServer()
			gameObjectServer.addListener(-999);
			gameObjectServer.getMusicManager().setRadioMode(RADIO_MYMUSIC);
		end
	end )
	
	onMsg("noRadio", function(msg)
		playSound("switchOff");
		
		local gameObjectServer = this.getGameObjectServer()
		gameObjectServer.addListener(-999);
		gameObjectServer.getMusicManager().setRadioMode(RADIO_OFF);
		
		this.unlock(); -- for random breaking
	end )
	
	
	-- repair
	onMsg("repair", function(msg)
	
		print("onMsg repair");
		-- get character who initiated this action
		local character = getStateObjectFromID(msg.sender);
		-- walk to the closest action point
		local actionPoint = character.getClosestFreeActionPoint(character, this, {"repair1", "repair2", "repair3", "repair4"});
		-- get the walk state object
		local wso = character.walkSO;
		if (actionPoint) then
			-- create state machine contexts
			local wsoContext = StateMachineContext();
			-- store the action point
			wsoContext.storeData("actionPointName", actionPoint.getName());
			if (wso.walkToActionPoint(actionPoint)) then
				wso.queueStateMachine("repairChar.repairStart", this, wsoContext);
			else
				print("no path found");
				instantAbort(character, EMOTICON_NOPATH, "emoThink")
			end
		else
			print("no action point found");
			instantAbort(character, EMOTICON_CANNOT, "emoThink")
		end
	end )	

			
endStateMachine()
